--- 
-- @param user -
-- @param dialogTree -
-- @param name - 
function ExportDialog(user,dialogTree,name)
	local fileName = ""
	local fileStream = nil
	local directory = "mods/"..GetModName().."/scripts/"
	-- remove this when you get the filename dialog ready
	name = "test file"
	-- format the filename to lower case and build the string
	name = string.lower(name)
	name = string.gsub(name," ","_")
	name = string.gsub(name,"'","")
	fileName = "ai_" .. name
	
	fileStream = io.open(directory .. fileName .. ".lua","w")
	
	WriteRequirements(fileStream,dialogTree)
	WriteDialogFunctions(fileStream,dialogTree)

	fileStream:close()	
	
end

--- 
-- @param fileStream -
function WriteRequirements(fileStream,dialogTree)
	fileStream:write("-- grab the Dialog code from the base_ai_npc file\n")
	fileStream:write("require 'base_ai_npc'\n\n")
	fileStream:write("-- set some general npc flags\n")
	fileStream:write("AI.Settings.EnableTrain = false\n")
	fileStream:write("AI.Settings.MerchantEnabled = false\n")
	fileStream:write("AI.Settings.SkipIntroDialog = true\n")
	if(IsBanker(dialogTree)) then
		fileStream:write("AI.Settings.EnableBank = true\n")
		fileStream:write("this:SetObjVar(\"AI-EnableBank\",true)\n")
	end
end

--- 
-- @param fileStream -
-- @param dialogTree -
function WriteDialogFunctions(fileStream,dialogTree)
	-- loop through each dialog node and generate the scripted functions
	for key,value in pairs(dialogTree) do
		fileStream:write("\n")
		
		--function declaration
		fileStream:write("---------------------------------------------------------------------------\n")
		fileStream:write("-- "..key.. " Node\n")
		fileStream:write("---------------------------------------------------------------------------\n")
		fileStream:write("--- this opens the " .. key .. " part of the dialog\n")
		fileStream:write("--@ param user - the user object to display the dialog node too\n")
		fileStream:write("function Dialog.Open" .. key .. "Dialog(user)\n")
		
		-- function body
		fileStream:write("\t-- the npc text dialog to display to the player\n")
		fileStream:write("\tlocal text = \"" .. value.NpcDialog .. "\"\n")
		fileStream:write("\t-- the table to hold the player response info\n")
		fileStream:write("\tlocal response = {}\n\n")
		
		-- write the player response code here
		WritePlayerResponses(fileStream,dialogTree,key)

		-- write citadels dialog interaction code
		fileStream:write("\t-- load up the new npc interaction dynamic window for the user\n")
		fileStream:write("\tNPCInteraction(text,this,user,\"Responses\",response)\n\n")
		
		-- face npc towards user
		fileStream:write("\t-- set the attention of the npc to the user who is interacting with it\n")
		fileStream:write("\tGetAttention(user)\n")
		
		--end function
		fileStream:write("end\n")
	end
end

--- 
-- @param fileStream -
-- @param dialogTree -
function WritePlayerResponses(fileStream,dialogTree,node)
	for key,value in pairs(dialogTree[node].Player.Responses) do
  		fileStream:write("\tresponse[" .. key .. "]={}\n")
  		fileStream:write("\tresponse[" .. key .. "].text = \"" .. value.Text .. "\"\n")
  		fileStream:write("\tresponse[" .. key .. "].handle =\"" .. GetResponseHandle(dialogTree,node,key) .. "\"\n")
  		fileStream:write("\n")
	end
end

--- 
-- @param dialogTree -
-- @param node -
-- @param responseIndex -
function GetResponseHandle(dialogTree,node,responseIndex)
	for key,value in pairs(dialogTree[node].Player.Responses[responseIndex].Actions) do
	    if(value.Type == "GotoNode") then return value.Values end
	    if(value.Type == "OpenBank") then return "Bank" end
	end 
	return ""
end

--- 
-- @param dialogTree -
function IsBanker(dialogTree)
	for key,value in pairs(dialogTree) do
		for index,response in pairs(value.Player.Responses) do
			for i, t in pairs(response.Actions) do
				if(t.Type == "OpenBank") then return true end
			end
		end
	end
	return false
end
